
#define _CRT_SECURE_NO_DEPRECATE
#define _CRT_NONSTDC_NO_DEPRECATE

#ifdef WIN32
#include <windows.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <GL/gl.h>
#include <GL/glu.h>

#include <string>
using std::string;

#include <vector>
using std::vector;

#include <algorithm>

#include "wx/wxprec.h"

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif

// Define some variable types
#define BYTE unsigned char
#define WORD unsigned short
#define DWORD unsigned long

// A macro to check if a value exists in a vector
#define vector_exists(vec, val) find(vec.begin(), vec.end(), val) != vec.end()

// A macro to add a value to a vector if the value doesn't already exist in the vector
#define vector_add_nodup(vec, val) if (!(vector_exists(vec, val))) vec.push_back(val)

// Define min and max
#ifndef max
#define max(a,b) (((a)>(b))?(a):(b))
#endif
#ifndef min
#define min(a,b) (((a)<(b))?(a):(b))
#endif

// Some basic colours
#define COL_WHITE	rgba_t(255, 255, 255, 255)
#define COL_BLACK	rgba_t(0, 0, 0, 255)
#define COL_RED		rgba_t(255, 0, 0, 255)
#define COL_GREEN	rgba_t(0, 255, 0, 255)
#define COL_BLUE	rgba_t(0, 0, 255, 255)

// Editor stuff
#define MAJOR_UNIT 32

#include "structs.h"
#include "tokenizer.h"
#include "cvar.h"
#include "wad.h"

class MainApp : public wxApp
{
public:
	virtual bool OnInit();
	virtual int OnExit();
};

string parse_string(char *str, ...);
string str_upper(string str);
string wx_to_str(wxString str);
wxString str_to_wx(string str);
