
#include "main.h"
#include "action_special.h"
#include "special_select.h"

SpecialSelectDialog::SpecialSelectDialog(int init)
:	wxDialog(NULL, -1, _T("Select Action Special"), wxDefaultPosition, wxDefaultSize)
{
	wxBoxSizer *m_vbox = new wxBoxSizer(wxVERTICAL);
	SetSizer(m_vbox);

	tree = new wxTreeCtrl(this, SD_TREE, wxDefaultPosition, wxSize(300, 300), wxTR_DEFAULT_STYLE|wxTR_HIDE_ROOT);
	m_vbox->Add(tree, 1, wxEXPAND|wxALL, 4);

	selected_val = init;
	populate_tree_specials(tree, init);

	m_vbox->Add(CreateButtonSizer(wxOK|wxCANCEL), 0, wxEXPAND|wxALL, 4);

	Layout();
	SetBestFittingSize();
}

SpecialSelectDialog::~SpecialSelectDialog()
{
}

BEGIN_EVENT_TABLE(SpecialSelectDialog, wxDialog)
	EVT_TREE_SEL_CHANGING(SD_TREE, SpecialSelectDialog::tree_selection_changed)
	EVT_TREE_ITEM_ACTIVATED(SD_TREE, SpecialSelectDialog::tree_item_activated)
END_EVENT_TABLE()

void SpecialSelectDialog::tree_selection_changed(wxTreeEvent &event)
{
	if (tree->ItemHasChildren(event.GetItem()))
		selected_val = -1;
	else
	{
		wxString spec = tree->GetItemText(event.GetItem());

		if (spec != _T(""))
			sscanf(wx_to_str(spec).c_str(), "%d", &selected_val);
	}
}

void SpecialSelectDialog::tree_item_activated(wxTreeEvent &event)
{
	if (!tree->ItemHasChildren(event.GetItem()))
		EndModal(wxID_OK);
}
