
#include "main.h"
#include "splash.h"

SplashWindow *splash_window;

SplashWindow::SplashWindow()
//:	wxPanel(NULL, -1)
:	wxFrame(NULL, -1, _T(""), wxDefaultPosition, wxSize(590, -1), wxRAISED_BORDER)//wxCAPTION)
{
	wxBoxSizer *vbox = new wxBoxSizer(wxVERTICAL);
	SetSizer(vbox);

	logo = new ImageBox(this, "res/logo.png");
	vbox->Add(logo, 0, wxEXPAND);

	message = new wxStaticText(this, -1, _T("Hello"), wxDefaultPosition, wxDefaultSize, wxALIGN_CENTRE);
	vbox->Add(message, 0, wxEXPAND);

	progress = new wxGauge(this, -1, 100);
	vbox->Add(progress, 0, wxEXPAND);

	Layout();
	Show(true);
	SetBestFittingSize();
	Center();
}

SplashWindow::~SplashWindow()
{
}

void SplashWindow::SetMessage(string message)
{
	this->message->SetLabel(str_to_wx(message));
	Layout();
}

void setup_splash()
{
	splash_window = new SplashWindow();
}

void splash(string message, bool progbar)
{
	splash_window->Show();
	splash_window->ShowProgress(progbar);
	splash_window->SetMessage(message);
	splash_window->SetProgress(0);
	splash_window->SetBestFittingSize();
	splash_window->Layout();
	splash_window->Update();
}

void splash_hide()
{
	splash_window->Hide();
}

void splash_progress(double prog)
{
	splash_window->SetProgress(prog * 100);
	splash_window->Update();
}
