
#include <wx/glcanvas.h>
#include <wx/spinctrl.h>

class TexBrowseCanvas : public wxGLCanvas
{
private:

public:
	wxDialog		*parent;
	wxScrollBar		*vscroll;
	wxTextCtrl		*search;
	wxArrayString	tex_names;
	string			selected_tex;
	bool			sprites;

	TexBrowseCanvas(wxWindow *parent);
	~TexBrowseCanvas();

	void search_str(string str);
	void scroll_to_selected();
	void redraw();

	void mouse_event(wxMouseEvent& event);
	void key_down(wxKeyEvent &event);
	void paint(wxPaintEvent &event);
	void resize(wxSizeEvent &event);

	DECLARE_EVENT_TABLE()
};


class TextureBrowser : public wxDialog
{
private:
	TexBrowseCanvas	*browse_area;
	wxScrollBar		*vscroll;
	wxTextCtrl		*search;
	wxChoice		*sorting;
	wxSpinCtrl		*n_columns;
	wxCheckBox		*cb_iwad_textures;

	int				browse_type;

public:
	enum
	{
		BROWSER_VSCROLL,
		BROWSER_SEARCH,
		BROWSER_SORTING,
		BROWSER_COLS,
		BROWSER_CB_IWADTEXTURES,
	};

	TextureBrowser(int type = 1, string tex = "-", bool fullscreen = false);
	~TextureBrowser();

	string get_texture();
	void sort(int sorting);
	void populate_texture_list();

	void key_down(wxKeyEvent &event);
	void scroll_event(wxScrollEvent &event);
	void search_changed(wxCommandEvent &event);
	void sorting_changed(wxCommandEvent &event);
	void columns_changed(wxSpinEvent &event);
	void cb_iwadtextures_toggled(wxCommandEvent &event);

	DECLARE_EVENT_TABLE()
};
