
#include "main.h"
#include "line_edit.h"
#include "thing_edit.h"
#include "map.h"
#include "special_select.h"
#include "ttype_select.h"
#include "checks.h"
#include "args_edit.h"
#include "action_special.h"


extern int hilight_item;
extern vector<int> selected_items;
extern thing_t last_thing;

ThingEditor::ThingEditor(int type)
:	wxDialog(NULL, -1, _T("Edit Thing"), wxDefaultPosition, wxDefaultSize)
{
	wxBoxSizer *m_vbox = new wxBoxSizer(wxVERTICAL);
	SetSizer(m_vbox);

	// Flags frame
	wxStaticBox *frame = new wxStaticBox(this, -1, _T("Flags"));
	wxStaticBoxSizer *box = new wxStaticBoxSizer(frame, wxHORIZONTAL);
	m_vbox->Add(box, 0, wxEXPAND|wxALL, 4);

	// Flags
	wxBoxSizer *vbox = NULL;

	int flags_per_col = 5;
	if (map.thing_flags.size() > 15)
		flags_per_col = (map.thing_flags.size() / 3) + 1;

	int f = 0;
	int cols = (map.thing_flags.size() / flags_per_col) + 1;
	for (int a = 0; a < cols; a++)
	{
		if (f >= map.thing_flags.size())
			continue;

		vbox = new wxBoxSizer(wxVERTICAL);
		box->Add(vbox, 1, wxEXPAND);

		for (int b = 0; b < flags_per_col; b++)
		{
			if (f >= map.thing_flags.size())
				continue;

			setup_flag_checkbox(map.thing_flags[f].value, str_to_wx(map.thing_flags[f].name), vbox);
			f++;
		}
	}

	wxBoxSizer *hbox = new wxBoxSizer(wxHORIZONTAL);
	m_vbox->Add(hbox, 0, wxEXPAND);

	// Type frame
	frame = new wxStaticBox(this, -1, _T("Type"));
	box = new wxStaticBoxSizer(frame, wxVERTICAL);
	hbox->Add(box, 1, wxEXPAND|wxALL, 4);

	wxBoxSizer *hbox2 = new wxBoxSizer(wxHORIZONTAL);
	box->Add(hbox2, 1, wxEXPAND);

	type_entry = new wxTextCtrl(this, TE_ENTRY_TYPE, _T(""));
	sprite = new ClickableTexBox(this, 96, 96, type_entry, "_none_", 3, 2.0f);
	sprite->Enable(true);
	hbox2->Add(sprite, 1, wxEXPAND|wxALL, 4);

	vbox = new wxBoxSizer(wxVERTICAL);
	hbox2->Add(vbox, 0, wxEXPAND);

	vbox->Add(type_entry, 1, wxALL, 4);

	change_type = new wxButton(this, TE_BTN_CHANGETYPE, _T("Change"));
	vbox->Add(change_type, 1, wxEXPAND|wxALL, 4);

	browse_type = new wxButton(this, TE_BTN_BROWSETYPE, _T("Browse"));
	vbox->Add(browse_type, 1, wxEXPAND|wxALL, 4);

	type_label = new wxStaticText(this, -1, _T("Type"));
	box->Add(type_label, 0, wxEXPAND|wxALL, 4);

	// Angle frame
	frame = new wxStaticBox(this, -1, _T("Angle"));
	box = new wxStaticBoxSizer(frame, wxVERTICAL);
	hbox->Add(box, 0, wxEXPAND|wxALL, 4);

	angle_n = new wxRadioButton(this, TE_RADIO_N, _T(""), wxDefaultPosition, wxDefaultSize, wxRB_GROUP);
	angle_ne = new wxRadioButton(this, TE_RADIO_NE, _T(""));
	angle_e = new wxRadioButton(this, TE_RADIO_E, _T(""));
	angle_se = new wxRadioButton(this, TE_RADIO_SE, _T(""));
	angle_s = new wxRadioButton(this, TE_RADIO_S, _T(""));
	angle_sw = new wxRadioButton(this, TE_RADIO_SW, _T(""));
	angle_w = new wxRadioButton(this, TE_RADIO_W, _T(""));
	angle_nw = new wxRadioButton(this, TE_RADIO_NW, _T(""));
	angle_unknown = new wxRadioButton(this, -1, _T(""));
	angle_unknown->Hide();

	wxGridSizer *grid = new wxGridSizer(5, 5, 4, 4);
	box->Add(grid, 1, wxEXPAND|wxALL, 4);

	// Yeah, I know its ugly. I can't find a better way to do this
	grid->AddSpacer(0);
	grid->AddSpacer(0);
	grid->Add(angle_n);
	grid->AddSpacer(0);
	grid->AddSpacer(0);
	grid->AddSpacer(0);
	grid->Add(angle_nw);
	grid->AddSpacer(0);
	grid->Add(angle_ne);
	grid->AddSpacer(0);
	grid->Add(angle_w);
	grid->AddSpacer(0);
	grid->AddSpacer(0);
	grid->AddSpacer(0);
	grid->Add(angle_e);
	grid->AddSpacer(0);
	grid->Add(angle_sw);
	grid->AddSpacer(0);
	grid->Add(angle_se);
	grid->AddSpacer(0);
	grid->AddSpacer(0);
	grid->AddSpacer(0);
	grid->Add(angle_s);

	angle_entry = new wxTextCtrl(this, TE_ENTRY_ANGLE, _T(""));
	box->Add(angle_entry, 0, wxEXPAND|wxALL, 4);

	if (map.hexen)
	{
		wxBoxSizer *hbox = new wxBoxSizer(wxHORIZONTAL);
		m_vbox->Add(hbox, 0, wxEXPAND);
		
		// TID frame
		frame = new wxStaticBox(this, -1, _T("Thing ID"));
		box = new wxStaticBoxSizer(frame, wxHORIZONTAL);
		hbox->Add(box, 0, wxEXPAND|wxALL, 4);

		tid_entry = new wxTextCtrl(this, TE_ENTRY_TID, _T(""), wxDefaultPosition, wxSize(56, -1));
		box->Add(tid_entry, 1, wxEXPAND|wxRIGHT, 4);

		find_tid = new wxButton(this, TE_BTN_FINDTID, _T("Find Free"));
		box->Add(find_tid, 0, wxEXPAND);

		// Z Height frame
		frame = new wxStaticBox(this, -1, _T("Z Height"));
		box = new wxStaticBoxSizer(frame, wxHORIZONTAL);
		hbox->Add(box, 0, wxEXPAND|wxALL, 4);

		z_entry = new wxTextCtrl(this, TE_ENTRY_Z, _T(""), wxDefaultPosition, wxSize(56, -1));
		box->Add(z_entry, 1, wxEXPAND);

		// Special frame
		frame = new wxStaticBox(this, -1, _T("Action Special"));
		box = new wxStaticBoxSizer(frame, wxHORIZONTAL);
		hbox->Add(box, 0, wxEXPAND|wxALL, 4);

		special_entry = new wxTextCtrl(this, TE_ENTRY_SPECIAL, _T(""), wxDefaultPosition, wxSize(56, -1));
		box->Add(special_entry, 1, wxEXPAND|wxRIGHT, 4);

		change_special = new wxButton(this, TE_BTN_CHANGESPECIAL, _T("Change"));
		box->Add(change_special, 0, wxEXPAND);

		// Args frame
		frame = new wxStaticBox(this, -1, _T("Args"));
		box = new wxStaticBoxSizer(frame, wxHORIZONTAL);
		hbox->Add(box, 0, wxEXPAND|wxALL, 4);

		edit_args = new wxButton(this, TE_BTN_EDITARGS, _T("Edit Args"));
		box->Add(edit_args, 0, wxEXPAND);
	}

	m_vbox->Add(CreateButtonSizer(wxOK|wxCANCEL), 0, wxEXPAND|wxALL, 4);

	setup_widgets();
	Layout();
	SetBestFittingSize();
	Center();
}

ThingEditor::~ThingEditor()
{
}

void ThingEditor::setup_flag_checkbox(WORD flag, wxString label, wxSizer *box)
{
	FlagCheckBox *flag_cb = new FlagCheckBox(this, flag, label);
	flags.push_back(flag_cb);
	box->Add(flag_cb, 0, wxBOTTOM, 2);
}

void ThingEditor::setup_widgets()
{
	// Single item
	if (selected_items.size() == 0 && hilight_item != -1)
	{
		// Flags
		for (int a = 0; a < flags.size(); a++)
		{
			if (map.things[hilight_item]->flags & flags[a]->flag)
				flags[a]->Set3StateValue(wxCHK_CHECKED);
		}

		// Type
		type_entry->SetValue(wxString::Format(_T("%d"), map.things[hilight_item]->type));

		// Angle
		angle_entry->SetValue(wxString::Format(_T("%d"), map.things[hilight_item]->angle));

		if (map.hexen)
		{
			// TID
			tid_entry->SetValue(wxString::Format(_T("%d"), map.things[hilight_item]->tid));

			// Z height
			z_entry->SetValue(wxString::Format(_T("%d"), map.things[hilight_item]->z));

			// Special
			special_entry->SetValue(wxString::Format(_T("%d"), map.things[hilight_item]->special));

			// Args
			memcpy(args, map.things[hilight_item]->args, 5);
			memset(args_consistent, 1, 5);
		}

	}

	// Multiple items
	if (selected_items.size() > 0)
	{
		// Flags
		for (int a = 0; a < flags.size(); a++)
		{
			if (map.things[selected_items[0]]->flags & flags[a]->flag)
				flags[a]->Set3StateValue(wxCHK_CHECKED);
		}

		// Type
		type_entry->SetValue(wxString::Format(_T("%d"), map.things[selected_items[0]]->type));

		// Angle
		angle_entry->SetValue(wxString::Format(_T("%d"), map.things[selected_items[0]]->angle));

		if (map.hexen)
		{
			// TID
			tid_entry->SetValue(wxString::Format(_T("%d"), map.things[selected_items[0]]->tid));

			// Z height
			z_entry->SetValue(wxString::Format(_T("%d"), map.things[selected_items[0]]->z));

			// Special
			special_entry->SetValue(wxString::Format(_T("%d"), map.things[selected_items[0]]->special));

			// Args
			memcpy(args, map.things[selected_items[0]]->args, 5);
			memset(args_consistent, 1, 5);
		}

		// Check for inconsistency
		for (int a = 0; a < selected_items.size(); a++)
		{
			for (int b = 0; b < flags.size(); b++)
			{
				if (flags[b]->Get3StateValue() == wxCHK_UNDETERMINED)
					continue;

				bool on = map.things[selected_items[a]]->flags & flags[b]->flag;
				if (on && flags[b]->Get3StateValue() == wxCHK_UNCHECKED ||
					!on && flags[b]->Get3StateValue() == wxCHK_CHECKED)
					flags[b]->Set3StateValue(wxCHK_UNDETERMINED);
			}

			if (map.things[selected_items[a]]->type != map.things[selected_items[0]]->type)
				type_entry->SetValue(_T(""));

			if (map.things[selected_items[a]]->angle != map.things[selected_items[0]]->angle)
				angle_entry->SetValue(_T(""));

			if (map.hexen)
			{
				if (map.things[selected_items[a]]->tid != map.things[selected_items[0]]->tid)
					tid_entry->SetValue(_T(""));

				if (map.things[selected_items[a]]->z != map.things[selected_items[0]]->z)
					z_entry->SetValue(_T(""));

				if (map.things[selected_items[a]]->special != map.things[selected_items[0]]->special)
					special_entry->SetValue(_T(""));

				for (int b = 0; b < 5; b++)
				{
					if (map.things[selected_items[a]]->args[b] != map.things[selected_items[0]]->args[b])
						args_consistent[b] = false;
				}
			}
		}
	}
}

void ThingEditor::apply_changes()
{
	vector<thing_t*> items;

	// Get items to modify
	items.push_back(&last_thing);

	if (selected_items.size() == 0 && hilight_item != -1)
		items.push_back(map.things[hilight_item]);

	if (selected_items.size() > 0)
	{
		for (int a = 0; a < selected_items.size(); a++)
			items.push_back(map.things[selected_items[a]]);
	}
	
	for (int a = 0; a < items.size(); a++)
	{
		// Flags
		for (int b = 0; b < flags.size(); b++)
			flags[b]->apply_flag((WORD*)&(items[a]->flags));

		// Type
		if (type_entry->GetValue() != _T(""))
			items[a]->type = atoi(wx_to_str(type_entry->GetValue()).c_str());

		// Angle
		if (angle_entry->GetValue() != _T(""))
			items[a]->angle = atoi(wx_to_str(angle_entry->GetValue()).c_str());

		if (map.hexen)
		{
			// Args
			for (int b = 0; b < 5; b++)
			{
				if (args_consistent[b])
					items[a]->args[b] = args[b];
			}

			// TID
			if (tid_entry->GetValue() != _T(""))
				items[a]->tid = atoi(wx_to_str(tid_entry->GetValue()).c_str());

			// Z height
			if (z_entry->GetValue() != _T(""))
				items[a]->z = atoi(wx_to_str(z_entry->GetValue()).c_str());

			// Special
			for (int a = 0; a < items.size(); a++)
				items[a]->special = atoi(wx_to_str(special_entry->GetValue()).c_str());
		}

		items[a]->ttype = get_thing_type(items[a]->type);
	}

	map.change_level(MC_THINGS);
}

BEGIN_EVENT_TABLE(ThingEditor, wxDialog)
	EVT_RADIOBUTTON(TE_RADIO_N, ThingEditor::angle_radio_changed)
	EVT_RADIOBUTTON(TE_RADIO_NE, ThingEditor::angle_radio_changed)
	EVT_RADIOBUTTON(TE_RADIO_E, ThingEditor::angle_radio_changed)
	EVT_RADIOBUTTON(TE_RADIO_SE, ThingEditor::angle_radio_changed)
	EVT_RADIOBUTTON(TE_RADIO_S, ThingEditor::angle_radio_changed)
	EVT_RADIOBUTTON(TE_RADIO_SW, ThingEditor::angle_radio_changed)
	EVT_RADIOBUTTON(TE_RADIO_W, ThingEditor::angle_radio_changed)
	EVT_RADIOBUTTON(TE_RADIO_NW, ThingEditor::angle_radio_changed)
	EVT_TEXT(TE_ENTRY_TYPE, ThingEditor::type_entry_changed)
	EVT_TEXT(TE_ENTRY_ANGLE, ThingEditor::angle_entry_changed)
	EVT_BUTTON(TE_BTN_CHANGETYPE, ThingEditor::change_type_clicked)
	EVT_BUTTON(TE_BTN_FINDTID, ThingEditor::find_tid_clicked)
	EVT_BUTTON(TE_BTN_CHANGESPECIAL, ThingEditor::change_special_clicked)
	EVT_BUTTON(TE_BTN_EDITARGS, ThingEditor::edit_args_clicked)
END_EVENT_TABLE()

void ThingEditor::angle_radio_changed(wxCommandEvent &event)
{
	int angle = 0;
	switch (event.GetId())
	{
	case TE_RADIO_N:
		angle = 90; break;
	case TE_RADIO_NE:
		angle = 45; break;
	case TE_RADIO_E:
		angle = 0; break;
	case TE_RADIO_SE:
		angle = 315; break;
	case TE_RADIO_S:
		angle = 270; break;
	case TE_RADIO_SW:
		angle = 225; break;
	case TE_RADIO_W:
		angle = 180; break;
	case TE_RADIO_NW:
		angle = 135; break;
	default:
		angle = -1; break;
	}

	if (angle != -1)
		angle_entry->SetValue(str_to_wx(parse_string("%d", angle)));
	else
		angle_entry->SetValue(_T(""));
}

void ThingEditor::type_entry_changed(wxCommandEvent &event)
{
	if (type_entry->GetValue() != _T(""))
	{
		thing_type_t *ttype = get_thing_type(atoi(wx_to_str(type_entry->GetValue()).c_str()));
		type_label->SetLabel(str_to_wx(ttype->name));
		sprite->set_texture(ttype->spritename, 3);
	}
	else
	{
		type_label->SetLabel(_T("(Inconsistent / Don't Change)"));
		sprite->set_texture("_none_", 3);
	}
}

void ThingEditor::angle_entry_changed(wxCommandEvent &event)
{
	angle_unknown->SetValue(true);
	if (angle_entry->GetValue() != _T(""))
	{
		int angle = atoi(wx_to_str(angle_entry->GetValue()).c_str());

		if (angle == 0)
			angle_e->SetValue(true);
		if (angle == 45)
			angle_ne->SetValue(true);
		if (angle == 90)
			angle_n->SetValue(true);
		if (angle == 135)
			angle_nw->SetValue(true);
		if (angle == 180)
			angle_w->SetValue(true);
		if (angle == 225)
			angle_sw->SetValue(true);
		if (angle == 270)
			angle_s->SetValue(true);
		if (angle == 315)
			angle_se->SetValue(true);
	}
}

void ThingEditor::change_type_clicked(wxCommandEvent &event)
{
	int val = 0;
	if (type_entry->GetValue() != _T(""))
		val = atoi(wx_to_str(type_entry->GetValue()).c_str());

	TTypeSelectDialog td(val);
	if (td.ShowModal() == wxID_OK)
	{
		if (td.get_type() != -1)
			type_entry->SetValue(str_to_wx(parse_string("%d", td.get_type())));
	}
}

void ThingEditor::find_tid_clicked(wxCommandEvent &event)
{
	int tid = get_free_tid();
	tid_entry->SetValue(wxString::Format(_T("%d"), tid));
}

void ThingEditor::change_special_clicked(wxCommandEvent &event)
{
	int val = 0;
	if (special_entry->GetValue() != _T(""))
		val = atoi(wx_to_str(special_entry->GetValue()).c_str());

	SpecialSelectDialog sd(val);
	if (sd.ShowModal() == wxID_OK)
	{
		if (sd.get_special() != -1)
			special_entry->SetValue(wxString::Format(_T("%d"), sd.get_special()));
	}
}

void ThingEditor::edit_args_clicked(wxCommandEvent &event)
{
	int type = -1;
	if (type_entry->GetValue() != _T(""))
		type = atoi(wx_to_str(type_entry->GetValue()).c_str());

	thing_type_t *tt = get_thing_type(type);
	int result;

	if (tt->has_args)
	{
		ArgsEditor ae(args, tt->args, tt->arg_types, args_consistent);
		if (ae.ShowModal() == wxID_OK)
			ae.apply_changes(args, args_consistent);
	}
	else
	{
		int special = 0;
		if (special_entry->GetValue() != _T(""))
			special = atoi(wx_to_str(special_entry->GetValue()).c_str());

		action_special_t *as = get_special(special);

		ArgsEditor ae(args, as->args, as->arg_types, args_consistent);
		if (ae.ShowModal() == wxID_OK)
			ae.apply_changes(args, args_consistent);
	}
}
